﻿/// <reference name="MicrosoftAjax.js"/>

Type.registerNamespace("Bleroy.Sample");

Bleroy.Sample.CharCount = function(element) {
    Bleroy.Sample.CharCount.initializeBase(this, [element]);
    this._maxLen = 0;
    this._updateDelegate = null;
}
Bleroy.Sample.CharCount.prototype = {
    add_overflow: function(handler) {
        this.get_events().addHandler("overflow", handler);
    },
    remove_overflow: function(handler) {
        this.get_events().removeHandler("overflow", handler);
    },
    get_maxLength: function() {
        /// <value type="Number" isInteger="true">
        ///   The maximum number of characters in the textbox.
        /// </value>
        return this._maxLen;
    },
    set_maxLength: function(value) {
        this._maxLen = value;
    },
    get_length: function() {
        /// <value type="Number" isInteger="true">
        ///   The current number of characters in the textbox.
        /// </value>
        return this.get_element().value.length;
    },
    initialize: function() {
        this._updateDelegate = Function.createDelegate(this, this._update);
        Sys.UI.DomEvent.addHandler(this.get_element(), "blur", this._updateDelegate);
        Sys.UI.DomEvent.addHandler(this.get_element(), "keyup", this._updateDelegate);
        Sys.UI.DomEvent.addHandler(this.get_element(), "change", this._updateDelegate);
    },
    dispose: function() {
        if (this._updateDelegate) {
            Sys.UI.DomEvent.removeHandler(this.get_element(), "blur", this._updateDelegate);
            Sys.UI.DomEvent.removeHandler(this.get_element(), "keyup", this._updateDelegate);
            Sys.UI.DomEvent.removeHandler(this.get_element(), "change", this._updateDelegate);
            delete this._updateDelegate;
        }
    },
    _update: function(e) {
        if (this.get_length() > this.get_maxLength()) {
            var elt = this.get_element();
            elt.value = elt.value.substr(0, this.get_maxLength());
            var handler = this.get_events().getHandler("overflow");
            if (handler) {
                handler(this, new Sys.EventArgs());
            }
        }
    }
}
Bleroy.Sample.CharCount.registerClass("Bleroy.Sample.CharCount", Sys.UI.Behavior);